org.apache.lucene.search.similarities

## Class Similarity

- java.lang.Object
- - org.apache.lucene.search.similarities.Similarity

- Direct Known Subclasses:
    BM25Similarity, BooleanSimilarity, MultiSimilarity, PerFieldSimilarityWrapper, SimilarityBase, TFIDFSimilarity

      public abstract class Similarity
      extends Object

  Similarity defines the components of Lucene scoring.

  Expert: Scoring API.

  This is a low-level API, you should only extend this API if you want to implement an information retrieval model. If you are instead looking for a convenient way to alter Lucene's scoring, consider extending a higher-level implementation such as `TFIDFSimilarity`, which implements the vector space model with this API, or just tweaking the default implementation: `BM25Similarity`.

  Similarity determines how Lucene weights terms, and Lucene interacts with this class at both index-time and query-time.

  Indexing Time At indexing time, the indexer calls `computeNorm(FieldInvertState)`, allowing the Similarity implementation to set a per-document value for the field that will be later accessible via `LeafReader.getNormValues(String)`. Lucene makes no assumption about what is in this norm, but it is most useful for encoding length normalization information.

  Implementations should carefully consider how the normalization is encoded: while Lucene's `BM25Similarity` encodes a combination of index-time boost and length normalization information with `SmallFloat` into a single byte, this might not be suitable for all purposes.

  Many formulas require the use of average document length, which can be computed via a combination of `CollectionStatistics.sumTotalTermFreq()` and `CollectionStatistics.maxDoc()` or `CollectionStatistics.docCount()`, depending upon whether the average should reflect field sparsity.

  Additional scoring factors can be stored in named `NumericDocValuesField`s and accessed at query-time with `LeafReader.getNumericDocValues(String)`.

  Finally, using index-time boosts (either via folding into the normalization byte or via DocValues), is an inefficient way to boost the scores of different fields if the boost will be the same for every document, instead the Similarity can simply take a constant boost parameter C, and `PerFieldSimilarityWrapper` can return different instances with different boosts depending upon field name.

  Query time At query-time, Queries interact with the Similarity via these steps:

  1. The `computeWeight(float, CollectionStatistics, TermStatistics...)` method is called a single time, allowing the implementation to compute any statistics (such as IDF, average document length, etc) across the entire collection. The `TermStatistics` and `CollectionStatistics` passed in already contain all of the raw statistics involved, so a Similarity can freely use any combination of statistics without causing any additional I/O. Lucene makes no assumption about what is stored in the returned `Similarity.SimWeight` object.
  2. For each segment in the index, the Query creates a `simScorer(SimWeight, org.apache.lucene.index.LeafReaderContext)` The score() method is called for each matching document.

  Explanations When `IndexSearcher.explain(org.apache.lucene.search.Query, int)` is called, queries consult the Similarity's DocScorer for an explanation of how it computed its score. The query passes in a the document id and an explanation of how the frequency was computed.

  See Also:
    `IndexWriterConfig.setSimilarity(Similarity)`, `IndexSearcher.setSimilarity(Similarity)`
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Similarity.SimScorer` API for scoring "sloppy" queries such as `TermQuery`, `SpanQuery`, and `PhraseQuery`.
    `static class` | `Similarity.SimWeight` Stores the weight for a query across the indexed collection.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Similarity()` Sole constructor.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract long` | `computeNorm(FieldInvertState state)` Computes the normalization value for a field, given the accumulated state of term processing for this field (see `FieldInvertState`).
    `abstract Similarity.SimWeight` | `computeWeight(float boost, CollectionStatistics collectionStats, TermStatistics... termStats)` Compute any collection-level weight (e.g.
    `abstract Similarity.SimScorer` | `simScorer(Similarity.SimWeight weight, LeafReaderContext context)` Creates a new `Similarity.SimScorer` to score matching documents from a segment of the inverted index.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Similarity

          public Similarity()

      Sole constructor. (For invocation by subclass constructors, typically implicit.)

  - ### Method Detail

    - #### computeNorm

          public abstract long computeNorm(FieldInvertState state)

      Computes the normalization value for a field, given the accumulated state of term processing for this field (see `FieldInvertState`).

      Matches in longer fields are less precise, so implementations of this method usually set smaller values when `state.getLength()` is large, and larger values when `state.getLength()` is small.

      Parameters:
        `state` - current processing state for this field
      Returns:
        computed norm value
      WARNING: This API is experimental and might change in incompatible ways in the next release.

    - #### computeWeight

          public abstract Similarity.SimWeight computeWeight(float boost,
                                                             CollectionStatistics collectionStats,
                                                             TermStatistics... termStats)

      Compute any collection-level weight (e.g. IDF, average document length, etc) needed for scoring a query.
      Parameters:
        `boost` - a multiplicative factor to apply to the produces scores
        `collectionStats` - collection-level statistics, such as the number of tokens in the collection.
        `termStats` - term-level statistics, such as the document frequency of a term across the collection.
      Returns:
        SimWeight object with the information this Similarity needs to score a query.

    - #### simScorer

          public abstract Similarity.SimScorer simScorer(Similarity.SimWeight weight,
                                                         LeafReaderContext context)
                                                  throws IOException

      Creates a new `Similarity.SimScorer` to score matching documents from a segment of the inverted index.
      Parameters:
        `weight` - collection information from `computeWeight(float, CollectionStatistics, TermStatistics...)`
        `context` - segment of the inverted index to be scored.
      Returns:
        SloppySimScorer for scoring documents across `context`
      Throws:
        `IOException` - if there is a low-level I/O error

Copyright © 2000-2018 Apache Software Foundation. All Rights Reserved.